/**
***     cipherapp.hpp
***
***     Copyright (C) 2006 - 2008 SophiaCradle Incorporated.
***     All rights reserved.
***
***     ̃\[XR[h̓G[XgbvATXyhȂǂ̏Ă܂B
***     ۂ̎gpɍۂẮAKvɉďǉĂB
***
**/

#ifndef __CIPHERAPP_HPP
#define __CIPHERAPP_HPP

#include <SophiaFramework.hpp>

SFMTYPEDEFRESPONDER(MD5ARC4Frame)
SFMTYPEDEFRESPONDER(RSAFrame)
SFMTYPEDEFCLASS(cipherapp)
class cipherapp : public SFYApplication {
    SFMSEALCOPY(cipherapp)
    private:
        SFZTitleFlatFrameSmp _mainFrame;
        SFZWindowSmp _window;
        SFZSingleTextLabelControlSmp _labelTitle;
        SFZTextButtonControlSmp _button1;
        SFZTextButtonControlSmp _button2;
        MD5ARC4FrameSmp _md5arc4Frame;
        RSAFrameSmp _rsaFrame;
    public:
        static SFCInvokerPtr Factory(Void);
        SFCError Create(Void);
    private:
        explicit cipherapp(Void) static_throws;
        virtual ~cipherapp(Void);
        XANDLER_DECLARE_VOIDRESULT(OnMD5ARC4ButtonControl)
        XANDLER_DECLARE_VOIDRESULT(OnRSAButtonControl)

};

class MD5ARC4Frame : public SFZTitleFlatFrame {
    SFMSEALRESPONDER(MD5ARC4Frame)
    SFMRESPONDERINSTANTIATEFOUR(MD5ARC4Frame, SFZTitleFlatFrame, SFYFrame, SFYWidget, SFYResponder)

    private:
        SFZWindowSmp _window;
        SFZSingleTextLabelControlSmp _labelText;
        SFZSingleTextLabelControlSmp _labelKey;
        SFZSingleTextLabelControlSmp _labelEncodedText;
        SFZSingleEditBoxControlSmp _editboxText;
        SFZSingleEditBoxControlSmp _editboxKey;
        SFZSingleEditBoxControlSmp _editboxEncodedText;
        SFZTextButtonControlSmp _button1;
        SFZTextButtonControlSmp _button2;

        SFXBuffer _encodeBuffer;
    public:
        MD5ARC4Frame(Void);
        virtual ~MD5ARC4Frame(Void);
        static  MD5ARC4FrameSmp NewInstance(SFCErrorPtr exception = null);
        SFCError Create(Void);
        XANDLER_DECLARE_VOIDRESULT(OnEncodeButtonControl)
        XANDLER_DECLARE_VOIDRESULT(OnDecodeButtonControl)
};

class RSAFrame : public SFZTitleFlatFrame {
    SFMSEALRESPONDER(RSAFrame)
    SFMRESPONDERINSTANTIATEFOUR(RSAFrame, SFZTitleFlatFrame, SFYFrame, SFYWidget, SFYResponder)
    private:
        SFZWindowSmp _window;
        SFZSingleTextLabelControlSmp _labelText;
        SFZSingleTextLabelControlSmp _labelKey;
        SFZSingleTextLabelControlSmp _labelEncodedText;
        SFZSingleEditBoxControlSmp _editboxText;
        SFZSingleEditBoxControlSmp _editboxEncodedText;
        SFZTextButtonControlSmp _button1;
        SFZTextButtonControlSmp _button2;

        SFXBuffer _encodeBuffer;
        SFXCallback _callback;
        SFBRSASmp _rsa;
        VoidPtr _dest;
        SInt32 _size;
        UInt32 _ret;

    public:
        RSAFrame(Void);
        virtual ~RSAFrame(Void);
        static  RSAFrameSmp NewInstance(SFCErrorPtr exception = null);
        SFCError Create(Void);
        XANDLER_DECLARE_VOIDRESULT(OnEncodeButtonControl)
        XANDLER_DECLARE_VOIDRESULT(OnDecodeButtonControl)
        XALLBACK_DECLARE_SFXCALLBACK(RSAEncryptNotify)
        XALLBACK_DECLARE_SFXCALLBACK(RSADecryptNotify)
};

#endif // __CIPHERAPP_HPP //
